<template>
  <div class="user-overview">
    <LoadingSpinner v-if="loading" />
    <div v-if="loaded" class="mb-3">
      <router-link :to="usersRoute">
        <i class="bi bi-people-fill x2"></i>
        {{ userCountText }}
      </router-link>
    </div>
  </div>
</template>

<script>
import { ref, computed, onMounted } from 'vue'
import { StringHelper, LoadingSpinner, useApi, useNotification } from '../../core'
import UsersApi from '../api/users-api.js'

export default {
  name: 'UserOverview',
  components: {
    LoadingSpinner,
  },
  setup() {
    const api = useApi()
    const notify = useNotification()
    const usersApi = new UsersApi(api)

    const total = ref(0)
    const loading = ref(false)
    const loaded = ref(false)

    const usersRoute = computed(() => {
      return { name: 'identity-users' }
    })

    const userCountText = computed(() => {
      return StringHelper.noun(total.value, 'user', 'users')
    })

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false
      total.value = null

      try {
        const response = await usersApi.metadataAsync({ q: '' })
        total.value = parseInt(response.headers['x-total-count'])
        loaded.value = true
      } catch (ex) {
        notify.error('There was a problem getting the users metadata.', ex)
      } finally {
        loading.value = false
      }
    }

    onMounted(async () => {
      await loadAsync()
    })

    return {
      total,
      loading,
      loaded,
      usersRoute,
      userCountText,
    }
  },
}
</script>
